package at.ac.wu.examples.java2d;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Java2DDemo extends JFrame 
	implements ActionListener{
	
	private static enum Demos { SHAPE_DEMO, IMAGE_DEMO };
	private Demos displayDemo = Demos.SHAPE_DEMO;
	private MyComponent mc;
	
	private JButton bShapes;
	private JButton bImage;
	private JButton bNorth, bSouth, bWest, bEast;

	public Java2DDemo(String title) {
		super(title);
		
		// show control panel
		JPanel demoControlPanel = new JPanel();
		bShapes = new JButton("Shapes");
		bShapes.addActionListener(this);
		bImage = new JButton("Image");
		bImage.addActionListener(this);
		demoControlPanel.add(bShapes);
		demoControlPanel.add(bImage);
		
		this.add(demoControlPanel, BorderLayout.SOUTH);
		
		
		// create cursor control buttons
		bNorth = new JButton("N");
		bNorth.addActionListener(this);
		bSouth= new JButton("S");
		bSouth.addActionListener(this);
		bWest = new JButton("<-");
		bWest.addActionListener(this);
		bEast = new JButton("->");
		bEast.addActionListener(this);

		JPanel cursorControlPanel = new JPanel();	
		cursorControlPanel.add(bWest);
		cursorControlPanel.add(bNorth);
		cursorControlPanel.add(bSouth);
		cursorControlPanel.add(bEast);
		this.add(cursorControlPanel, BorderLayout.CENTER);
		
		// display custom component
		mc = new MyComponent(320, 200);
		this.add(mc, BorderLayout.NORTH);
		mc.drawShapes();
	}
	
	// input event handling (buttons) and
	// implementation of the ActionListener interface
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==bShapes) { 
			displayDemo = Demos.SHAPE_DEMO; 
		}
		else if (e.getSource()==bImage) {
			displayDemo = Demos.IMAGE_DEMO;
		}
		else if (e.getSource()==bWest) { mc.moveWest(); }
		else if (e.getSource()==bEast ) { mc.moveEast(); }
		else if (e.getSource()==bNorth) { mc.moveNorth(); }
		else if (e.getSource()==bSouth) { mc.moveSouth(); }
		
		// display the selected demo
		System.out.println(displayDemo);
		switch (displayDemo) {
		  case SHAPE_DEMO: mc.drawShapes(); break;
		  case IMAGE_DEMO: mc.drawImage(); break;
		}
	}
	
	// main method (static)
	// create an instance of the demo and execute it
	public static void main(String[] args) {
		Java2DDemo demo = new Java2DDemo("Java2D Demo");
		demo.pack();
		demo.setVisible( true );
	}
}
